package betterwithmods.client.container.other;

import betterwithmods.common.blocks.tile.TileEntityInfernalEnchanter;
import betterwithmods.common.items.ItemArcaneScroll;
import betterwithmods.util.InvUtils;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.ItemStackHandler;
import net.minecraftforge.items.SlotItemHandler;

import javax.annotation.Nullable;

/**
 * Created by tyler on 9/11/16.
 */
public class ContainerInfernalEnchanter extends Container {
    public int[] enchantLevels;
    public int xpSeed;
    private TileEntityInfernalEnchanter tile;
    private ItemStackHandler handler;

    public ContainerInfernalEnchanter(EntityPlayer player, TileEntityInfernalEnchanter tile) {
        this.tile = tile;
        this.enchantLevels = new int[5];
        handler = new ItemStackHandler(2) {
            @Override
            protected void onContentsChanged(int slot) {
                super.onContentsChanged(slot);
                onContextChanged(this);
            }
        };
        this.xpSeed = player.func_175138_ci();
        IItemHandler playerInv = player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        func_75146_a(new SlotItemHandler(handler, 0, 17, 37));
        func_75146_a(new SlotItemHandler(handler, 1, 17, 75));
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(playerInv, j + i * 9 + 9, 8 + j * 18, 129 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(playerInv, i, 8 + i * 18, 187));
        }

    }


    @Override
    @SideOnly(Side.CLIENT)
    public void func_75137_b(int id, int data) {
        if (id > 0 && id < 3) {
            enchantLevels[id] = data;
        } else if (id == 3) {
            xpSeed = data;
        }
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        for (IContainerListener listener : this.field_75149_d) {
            this.broadcastData(listener);
        }
    }

    @Override
    public void func_75132_a(IContainerListener listener) {
        super.func_75132_a(listener);
        broadcastData(listener);
    }

    public void broadcastData(IContainerListener listener) {
        listener.func_71112_a(this, 0, this.enchantLevels[0]);
        listener.func_71112_a(this, 1, this.enchantLevels[1]);
        listener.func_71112_a(this, 2, this.enchantLevels[2]);
        listener.func_71112_a(this, 3, this.xpSeed & -16);
    }

    public void onContextChanged(IItemHandler handler) {

        ItemStack scroll = handler.getStackInSlot(0);
        ItemStack toEnchant = handler.getStackInSlot(1);

        Enchantment enchantment = null;
        int enchantCount = 1;
        int maxBookcase = tile.getBookcaseCount();
        if (!scroll.func_190926_b() && !toEnchant.func_190926_b()) {
            enchantment = scroll.func_77978_p() != null ? Enchantment.func_185262_c(scroll.func_77978_p().func_74762_e("enchant")) : null;
            enchantCount = EnchantmentHelper.func_82781_a(toEnchant).size() + 1;


            //1,2,3,4
            //8,15,23,30
//            System.out.println(enchantment.getTranslatedName(-1) + "," + enchantCount + "," + maxBookcase + "," + enchantment.getMaxLevel());

        }
        for (int i = 1; i <= enchantLevels.length; i++) {
            if (enchantment == null || i > enchantment.func_77325_b())
                enchantLevels[i - 1] = 0;
            else
                enchantLevels[i - 1] = (int) Math.ceil(30 / Math.min(enchantLevels.length, enchantment.func_77325_b())) * i * enchantCount;
        }
        func_75142_b();
    }

    @Override
    @Nullable
    public ItemStack func_82846_b(EntityPlayer playerIn, int index) {
        ItemStack previous = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack current = slot.func_75211_c();
            previous = current.func_77946_l();

            // [...] Custom behaviour
            try {
                if (index > 1) {
                    if (current.func_77973_b() instanceof ItemArcaneScroll) {
                        if (!this.func_75135_a(current, 0, 1, true))
                            return ItemStack.field_190927_a;
                    } else if (!this.func_75135_a(current, 1, 2, true))
                        return ItemStack.field_190927_a;
                } else {
                    if (!this.func_75135_a(current, 2, field_75151_b.size() - 2, false))
                        return ItemStack.field_190927_a;
                }
            } catch (NullPointerException e) {
                e.printStackTrace();
            }

            if (current.func_190916_E() == 0)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();

            if (current.func_190916_E() == previous.func_190916_E())
                return ItemStack.field_190927_a;
            slot.func_190901_a(playerIn, current);
        }
        return previous;
    }

    @Override
    public boolean func_75145_c(EntityPlayer playerIn) {
        return true;
    }

    @Override
    public void func_75134_a(EntityPlayer playerIn) {
        for (int i = 0; i < handler.getSlots(); i++) {
            ItemStack stack = handler.getStackInSlot(i);

            if (!stack.func_190926_b() && !playerIn.func_130014_f_().field_72995_K)
                InvUtils.ejectStack(playerIn.func_130014_f_(), playerIn.field_70165_t, playerIn.field_70163_u, playerIn.field_70161_v, stack);
        }
    }

}
