package betterwithmods.client.gui;

import betterwithmods.BWMod;
import betterwithmods.module.hardcore.HCMovement;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.IAttributeInstance;
import net.minecraft.init.Items;
import net.minecraftforge.client.GuiIngameForge;
import net.minecraftforge.client.event.FOVUpdateEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

/**
 * Created by tyler on 5/13/17.
 */
@Mod.EventBusSubscriber(modid = BWMod.MODID, value = Side.CLIENT)
@SideOnly(Side.CLIENT)
public class GuiStatus {

    @SideOnly(Side.CLIENT)
    public static GuiStatus INSTANCE = new GuiStatus();
    public static boolean isGloomLoaded, isHungerLoaded, isInjuryLoaded;
    public static int offsetX, offsetY;
    private final Minecraft mc = Minecraft.func_71410_x();

    @SideOnly(Side.CLIENT)
    public void draw() {
        if (!PlayerHelper.isSurvival(mc.field_71439_g))
            return;
        ScaledResolution scale = ((GuiIngameForge) mc.field_71456_v).getResolution();
        int left = scale.func_78326_a() / 2 + 91 + offsetX;
        int top = scale.func_78328_b() - GuiIngameForge.right_height - 10 + offsetY;
        drawPenaltyText(left, top);
    }

    @SideOnly(Side.CLIENT)
    private boolean drawPenaltyText(int left, int top) {
        if (this.mc.field_71439_g.field_70128_L) {
            return false;
        } else {
            int y = top;
            FontRenderer fontRenderer = this.mc.field_71466_p;
            String injury = PlayerHelper.getHealthPenalty(mc.field_71439_g).getDescription();
            String gloom = PlayerHelper.getGloomPenalty(mc.field_71439_g).getDescription();
            String hunger = PlayerHelper.getWorstPenalty(mc.field_71439_g).getDescription();

            if (isInjuryLoaded && !injury.isEmpty()) {
                int width = fontRenderer.func_78256_a(injury);
                fontRenderer.func_175063_a(injury, left - width, y,
                        16777215);
                y -= 10;
            }

            if (isGloomLoaded && !gloom.isEmpty()) {
                int width = fontRenderer.func_78256_a(gloom);
                fontRenderer.func_175063_a(gloom, left - width, y,
                        16777215);
                y -= 10;
            }
            if (isHungerLoaded && !hunger.isEmpty()) {
                int width = fontRenderer.func_78256_a(hunger);
                fontRenderer.func_175063_a(hunger, left - width, y,
                        16777215);
                y -= 10;
            }
            GuiIngameForge.right_height += y;
            return false;
        }
    }

    @SubscribeEvent
    public static void onFOV(FOVUpdateEvent event) {
        float f = 1.0F;

        if (event.getEntity().field_71075_bZ.field_75100_b) {
            f *= 1.1F;
        }

        IAttributeInstance iattributeinstance = event.getEntity().func_110148_a(SharedMonsterAttributes.field_111263_d);

        double value = iattributeinstance.func_111126_e();
        if (iattributeinstance.func_111127_a(HCMovement.PENALTY_SPEED_UUID) != null) {
            value /= (1 + iattributeinstance.func_111127_a(HCMovement.PENALTY_SPEED_UUID).func_111164_d());
        }
        f = (float) ((double) f * ((value / (double) event.getEntity().field_71075_bZ.func_75094_b() + 1.0D) / 2.0D));


        if (event.getEntity().field_71075_bZ.func_75094_b() == 0.0F || Float.isNaN(f) || Float.isInfinite(f)) {
            f = 1.0F;
        }

        if (event.getEntity().func_184587_cr() && event.getEntity().func_184607_cu().func_77973_b() == Items.field_151031_f) {
            int i = event.getEntity().func_184612_cw();
            float f1 = (float) i / 20.0F;

            if (f1 > 1.0F) {
                f1 = 1.0F;
            } else {
                f1 = f1 * f1;
            }

            f *= 1.0F - f1 * 0.15F;
        }
        event.setNewfov(f);
    }
}
